package hegmonSharing;


import cern.jet.random.Uniform;
import java.awt.Image;
import javax.swing.ImageIcon;
import uchicago.src.sim.gui.Drawable;
import uchicago.src.sim.gui.SimGraphics;

public class ShareAgent implements Drawable{
	int field3, alive;// fields 1 and 2 are always the same type / alive =1, not alive, alive =0
	
	/*      Field Types: 2 akchin and one random,  
	 1 = akchin, 2 = trinchera, 3=arroyo bottom, 4= dune seepage 5 = terrace   */
	
	int hungry;  // true = 1, false = 2
	int harveststorage; // all households start with 266kg of corn in storage
	int houseX, houseY;//location of the household
	int shareType, currentHarvest, houseMalnourished, groupNumber, houseNumber;
	private static Image redHousePic, yellowHousePic, blackHousePic, greenHousePic;
    public ShareSpace sspace;
    public ShareModel smodel;
    
	public ShareAgent(ShareSpace ss, ShareModel model,  int share){
    	this.sspace =  ss;
    	smodel = model;
    	this.shareType = share;
    	getNewFields();
    	loadFarmPicture();
    	this.houseMalnourished =0;
    	if(this.shareType==0 || this.shareType==2){
    		this.harveststorage=266;
    	}
    } 
	
	private static void loadFarmPicture() {
		if (blackHousePic == null) {
			java.net.URL farmPicURL = ShareAgent.class.getResource("blackHouse.png");
			blackHousePic = new ImageIcon(farmPicURL).getImage(); 
		}
		if (redHousePic == null) {
			java.net.URL farmPicURL = ShareAgent.class.getResource("redHouse.png");
			redHousePic = new ImageIcon(farmPicURL).getImage(); 
		}
		if (yellowHousePic == null) {
			java.net.URL farmPicURL = ShareAgent.class.getResource("yellowHouse.png");
			yellowHousePic = new ImageIcon(farmPicURL).getImage(); 
		}
		if (greenHousePic == null) {
			java.net.URL farmPicURL = ShareAgent.class.getResource("greenHouse.png");
			greenHousePic = new ImageIcon(farmPicURL).getImage(); 
		}
	}
	public int getSharingType(){
		return this.shareType;
	}
	public int getX(){
		return this.houseX;
	}
	public void setX(int x){
		this.houseX= x;
	}
	public int getY(){
		return this.houseY;
	}
	public void setY(int y){
		this.houseY = y;
	}
	public int getHouseNumber(){
		return this.houseNumber;
	}
	public void setHouseNumber(int x){
		this.houseNumber = x;
	}
	public int getGroupNumber(){
		return this.groupNumber;
	}
	public void setGroupNumber(int x){
		this.groupNumber = x;
	}
	public void setMalnourishedState(){// model decides if still hungry after restricted sharing
		this.houseMalnourished ++;
	}
	public void setAliveStatus(int x){
		this.alive = x;
	}
	public int getAliveStatus(){
		return this.alive;
	}
	public void getNewFields(){
		this.field3 = Uniform.staticNextIntFromTo(2,5);	
	}
	
	public int calculateHarvest(){
		int harvest = this.sspace.calculateTotalYield(this.field3);
		//System.out.println("HouseNumber: " + this.houseNumber + " harvested: " + harvest+ "  year: "+this.sspace.getYear());
		return harvest;
	}
	
	public void poolingDistribute(int h){
		int harvest = h;
		if(harvest>=1017){
			this.houseMalnourished=0;
		}
		if(harvest < 1017){
			this.houseMalnourished++;//do support individual deaths here
		}
		if(this.houseMalnourished == 3){ // support for the groups demise
			smodel.groupFailure(this.groupNumber);
			houseDead();
		}
	}
	public void houseDead(){
		this.alive = 0;
		this.houseMalnourished =4;// so it doesn't keep reporting that its dead
		smodel.houseStarved(this.houseNumber);
		if(this.shareType==2){
			smodel.updateRestrictStatus(this.houseNumber, 3, 0);
		}
	}
	public int areYouHungry(){	
		return this.hungry;
	}
	public void setHungry(int h){
		this.hungry = h;
	}
	public int getHarvestStorage(){
		return this.harveststorage;
	}
	public void setHarvestStorage(int x){
		this.harveststorage = x;
	}
	
	public void draw(SimGraphics g){// changes the color of the house based upon the hunger status
		if(this.houseMalnourished==0){
			g.drawImage(greenHousePic);
		}
		if(this.houseMalnourished==1){
			g.drawImage(yellowHousePic);
		}
		if(this.houseMalnourished==2){
			g.drawImage(redHousePic);
		}
		if(this.houseMalnourished>=3){
			g.drawImage(blackHousePic);
		}
	  }
	public void step() {
		if(this.houseMalnourished ==3){
			houseDead();
			}	
		if (this.alive==1){
			this.currentHarvest = calculateHarvest();
			if (this.shareType == 0){// no sharing
				this.harveststorage = this.harveststorage+ this.currentHarvest;
				if(this.harveststorage>= 1017){
					this.harveststorage = this.harveststorage-1017;
					this.houseMalnourished=0;
				}
				else{ this.houseMalnourished++;
				this.harveststorage = 0;
				//System.out.println(":HouseNumber: : : : : : " + this.houseNumber + ":  was malnourished");
				}
			}
			if (this.shareType == 1){//pooling group
			smodel.sharePoolingHarvest(this.groupNumber, this.currentHarvest); //give all food away, storage is taken care of at the group level
			//System.out.println(":HouseNumber: : : : : : " + this.houseNumber+ ":GroupNumber: " + this.groupNumber  + ":  gave:  "+this.currentHarvest);
			}
			if (this.shareType == 2){//restricted sharing
				int x = this.harveststorage;
				this.harveststorage = x + this.currentHarvest;//first put everything into storage
				if(this.harveststorage>= 1017){
					this.harveststorage = this.harveststorage-1017;
					this.hungry = 2;
					smodel.updateRestrictStatus(this.houseNumber, this.hungry, this.harveststorage);
					this.houseMalnourished=0;
				}
				else{
					this.hungry = 1; // 1 is hungry, later can be changed by model.updatenewstoragenumbers
					smodel.updateRestrictStatus(this.houseNumber, this.hungry, this.harveststorage);
				}
				
			}
			
		}	
	}

}// end of ShareAgent

