package hegmonSharing;

import cern.jet.random.Uniform;
import uchicago.src.sim.space.Object2DGrid;

/*      Field Types: 2 akchin and one random  
1 = akchin, 2 = trinchera, 3=arroyo bottom, 4= dune seepage 5 = terrace   */

public class ShareSpace {
	private Object2DGrid agentSpace;
	private Object2DGrid gridSpace;
	
	//this could be input by reading from a file, but this was simpler. 
	//year / growing season length / growing season % of mean / rainfall amt / ranfall % of mean
int [][]weather = {{1932,158,106,87,110}, {1933,153,103,52,66},{1934,171,115,117,148},{1935,164,110,129,163},{1936,141,95,118,149},
{1937,168,113,75,95},{1938,154,103,78,99},{1939,133,89,23,29},{1940,153,103,65,82},
{1941,106,71,83,105},{1942,129,87,74,94},{1943,150,101,108,137},{1944,142,95,25,32},
{1945,156,105,78,99},{1946,176,118,77,97},{1947,193,130,86,109},{1948,149,100,17,22},
{1949,155,104,123,156},{1950,104,70,38,48},{1951,142,95,59,75},{1952,166,111,100,127},
{1953,127,85,111,141},{1954,166,114,88,121},{1956,151,104,87,119},{1957,146,101,109,149},
{1958,171,118,36,49},{1959,146,101,74,101},{1960,144,99,22,30},{1961,141,97,71,97},
{1962,155,107,11,15},{1963,173,119,125,171},{1964,162,112,70,96},{1965,113,78,73,100},
{1966,172,119,69,95},{1967,123,85,110,151},{1968,113,78,50,68},{1969,159,110,97,133},
{1970,131,90,52,71},{1971,117,81,35,48},{1972,153,106,102,140}};

	private int year;
	
	public ShareSpace(int x, int y){
		int xSize = x+10;
		int ySize = y+10;
		 agentSpace = new Object2DGrid(xSize, ySize);
		 gridSpace = new Object2DGrid(xSize, ySize);
		 for(int i = 0; i < xSize; i++){
		      for(int j = 0; j < ySize; j++){
		    	  gridSpace.putObjectAt(i,j,new Integer(0));
		      }
		    }
	}
	public int calculateTotalYield(int field){
		int total =0;
		if (field==2||field==3||field==5){
			int yield1 = calculateYield(1);
			int yield2 = calculateYield(1);
			int yield3 = calculateYield(field);
			total = yield1+yield2+yield3;
		}
		if(field==4){// households with type 4 fiels have smaller akchin fields, i.e. type 6
			int yield1 = calculateYield(6);
			int yield2 = calculateYield(6);
			int yield3 = calculateYield(field);
			total = yield1+yield2+yield3;
		}
		return total;
	}
	
	public int calculateYield(int field){
		int avgYield = 0;
		if(field ==1){
			avgYield = 710; //akchin field
		}
		if(field ==6){
			avgYield = 630; //smaller akchin field
			field=1; //treated like akchin field after this point
		}
		if(field ==4){
			avgYield = 267;//dune seepage
		}
		if(field ==2 || field ==3 || field==5){// terrace, trinchera, arroyo bottom fields
			avgYield = 213;
		}
		double yield;
		int gsPerMean;//gs is the growing season
		int rainfallPerMean;
		gsPerMean = getGsPerMean(); // calculate annual amt
		rainfallPerMean = getRainfallPerMean(); // calculate annual amt
		int rfVariation=  rainfallVariation(field); //changes the average from the mean
		rainfallPerMean = rainfallPerMean + rfVariation;
		int gsVariation = growingSeasonVariation(); //changes the average from the mean
		gsPerMean = gsPerMean+gsVariation;
		double flood =  floodProb(field,rainfallPerMean);
		yield = (avgYield * rainVariationCornYield(rainfallPerMean))* gsVariationCornYield(gsPerMean); //rainfall and gs variation
		yield = yield*flood;
		yield = yield*grasshoppers(); 
		yield = yield*damagingStorms();
		//System.out.println("yield: "+ yield);
		return (int)yield;
	}

	public int rainfallVariation(int field){
		int prob = Uniform.staticNextIntFromTo(1, 101);
		int percentChange = 0;
		if (field<=4){
			if (prob<=70){
				percentChange = 0;
			}
			if (70<prob&& prob<=80){
				percentChange = -20;
			}
			if (80<prob&& prob<=90){
				percentChange = 20;
			}
			if (90<prob&& prob<=95){
				percentChange =30;
			}
			if (95<prob&& prob<=100){
				percentChange = -30;
			}
		}
		if (field==5){
			if (prob<=70){
				percentChange = 0;
			}
			if (70<prob&& prob<80){
				percentChange = -10;
			}
			if (80<prob&& prob<90){
				percentChange =30;
			}
			if (90<prob&& prob<95){
				percentChange =40;
			}
			if (95<prob&& prob<100){
				percentChange = -20;
			}
		}
		return percentChange;
	}
	public int growingSeasonVariation(){
		double prob = Uniform.staticNextDoubleFromTo(0, 101);
		int percentChange = 0;
		if (prob<=85){
			percentChange = 0;
		}
		if (prob >85 && prob<=90){
			percentChange = 10;
		}
		if (prob >90 && prob<=95){
			percentChange = -10;
		}
		if (prob >95 && prob<=97.5){
			percentChange = -15;
		}
		if (prob >97.5 && prob<=100){
			percentChange = 15;
		}
		return percentChange;
	}
	public double rainVariationCornYield(int x){
		double y =0;
		 if (x<=50){
			 y=0.25;
		 }
		 if (x>=51 && x<=70){
			 y = 0.72;
		 }
		 if (x>=71 && x<=75){
			 y = 0.79;
		 }
		 if (x>=76 && x<=80){
			 y = 0.85;
		 }
		 if (x>=81 && x<=90){
			 y = 0.94;
		 }
		 if (x>=91 && x<=100){
			 y = 1;
		 }
		 if (x>=101 && x<=110){
			 y = 1.05;
		 }
		 if (x>=111){
			 y = 1.11;
		 }
		 return y;
	}
	public double gsVariationCornYield(int x){
		double y=1;
		if(x>=50 && x<=75){
			y=0.67;
		}
		if(x>=76 && x<=80){
			y=0.81;
		}
		if(x>=81 && x<=90){
			y=0.97;
		}
		return y;
	}
	public double floodProb (int field, double waterPercent){
		double x=1;//percent of the field which survives
		//if field == 4 no flooding can occur
		int flood=0;
		if (field==2 || field ==5 || field==1){
			if(waterPercent>=111 & waterPercent<=120){
				int prob = Uniform.staticNextIntFromTo(0, 101);
				if(prob<=20){
					flood=1;
				}
			}
			if(waterPercent>=121 & waterPercent<=130){
				int prob = Uniform.staticNextIntFromTo(0, 101);
				if(prob<=50){
					flood=1;
				}
			}
			if(waterPercent>=131){
					flood=1;
			}
		}
		if (field==3){
			if(waterPercent>=101 & waterPercent<=120){
				int prob = Uniform.staticNextIntFromTo(0, 101);
				if(prob<=50){
					flood=1;
					}
				}
			}
			if(waterPercent>=121){
					flood=1;
			}
		if (flood==1){
			int prob = Uniform.staticNextIntFromTo(0, 101);
			if (prob <=25){
				x=0;
			}
			if (prob<=50 && prob>26){
				x=0.75;
			}
			if (prob>=51){
				x=0.5;
			}
		}
		return x;
	}
	public double grasshoppers(){
		double x=1;
		int prob = Uniform.staticNextIntFromTo(0, 101);
		if(prob<=20){
			int prob2 = Uniform.staticNextIntFromTo(0, 101);
			if (prob2 <=25){
				x=0;
			}
			if (prob2<=50 && prob2>26){
				x=0.75;
			}
			if (prob2>=51){
				x=0.5;
			}
		}
		return x;
	}
	public double damagingStorms(){
		double x=1;
		int prob = Uniform.staticNextIntFromTo(0, 101);
		if(prob<=10){
			int prob2 = Uniform.staticNextIntFromTo(0, 101);
			if (prob2 <=25){
				x=0;
			}
			if (prob2<=50 && prob2>26){
				x=0.75;
			}
			if (prob2>=51){
				x=0.5;
			}
		}
		return x;
	}
	public int getGsPerMean (){
		if(year==1955){
			year=1956;
		}
		int x=0;
		for(int i = 0; i < 40; i++){
			if (year == weather[i][0]){		
				x= weather[i][2];
				i=40;
			}
		}
		return x;
	}
	public int getRainfallPerMean(){
		if(year==1955){
			year=1956;
		}
		int x=0;
		for(int i = 0; i < 40; i++){
			if (year == weather[i][0]){		
				x= weather[i][4];
				i=40;
			}
		}
		return x;
	}
	public void setYear(int x){
		year=x;
	}
	public int getYear (){
		return year;
	}
	public Object2DGrid getCurrentAgentSpace(){
		    return agentSpace;
	}
	  public Object2DGrid getCurrentGridSpace(){
		    return gridSpace;
		  }
	public boolean isCellOccupied(int x, int y){
		    boolean retVal = false;
		    if(agentSpace.getObjectAt(x, y)!=null) retVal = true;
		    return retVal;
	}

}

